import * as i0 from '@angular/core';
import { Directive, Input, NgModule } from '@angular/core';
import * as i1 from '@alyle/ui';
import { toBoolean, StyleRenderer } from '@alyle/ui';

const STYLES = (theme) => (_className) => `${_className}{display:block;background-color:${theme.divider};height:1px;}`;
class LyDivider {
    constructor(sRenderer) {
        this.sRenderer = sRenderer;
    }
    /** Add indentation (72px) */
    set inset(val) {
        const newVal = this._inset = toBoolean(val);
        if (newVal) {
            this[0x1] = this.sRenderer.add(`${LyDivider.и}--inset`, ({ before }) => (_className) => `${_className}{margin-${before}:74px;}`, this[0x1]);
        }
        else {
            this.sRenderer.removeClass(this[0x1]);
        }
    }
    get inset() {
        return this._inset;
    }
    ngOnInit() {
        this.sRenderer.add(STYLES);
    }
}
LyDivider.и = 'LyDivider';
LyDivider.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: LyDivider, deps: [{ token: i1.StyleRenderer }], target: i0.ɵɵFactoryTarget.Directive });
LyDivider.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.3.0", type: LyDivider, selector: "ly-divider", inputs: { inset: "inset" }, providers: [
        StyleRenderer
    ], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: LyDivider, decorators: [{
            type: Directive,
            args: [{
                    selector: 'ly-divider',
                    providers: [
                        StyleRenderer
                    ]
                }]
        }], ctorParameters: function () { return [{ type: i1.StyleRenderer }]; }, propDecorators: { inset: [{
                type: Input
            }] } });

class LyDividerModule {
}
LyDividerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: LyDividerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
LyDividerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.3.0", ngImport: i0, type: LyDividerModule, declarations: [LyDivider], exports: [LyDivider] });
LyDividerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: LyDividerModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.3.0", ngImport: i0, type: LyDividerModule, decorators: [{
            type: NgModule,
            args: [{
                    exports: [LyDivider],
                    declarations: [LyDivider]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { LyDivider, LyDividerModule };
//# sourceMappingURL=alyle-ui-divider.mjs.map
