"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tasks_1 = require("@angular-devkit/schematics/tasks");
const package_config_1 = require("../utils/package-config");
const AUI_VERSION = '14.0.0';
const HAMMERJS_VERSION = '^2.0.8';
const ANGULAR_CDK_VERSION = '^14.2.7';
function default_1(options) {
    return (host, context) => {
        context.logger.debug('installPkgs');
        const ngCoreVersionTag = (0, package_config_1.getPackageVersionFromPackageJson)(host, '@angular/core');
        if ((0, package_config_1.getPackageVersionFromPackageJson)(host, '@angular/cdk') === null) {
            (0, package_config_1.addPackageToPackageJson)(host, '@angular/cdk', ANGULAR_CDK_VERSION);
        }
        (0, package_config_1.addPackageToPackageJson)(host, '@angular/forms', ngCoreVersionTag);
        (0, package_config_1.addPackageToPackageJson)(host, '@angular/animations', ngCoreVersionTag);
        (0, package_config_1.addPackageToPackageJson)(host, '@alyle/ui', `^${AUI_VERSION}`);
        if (options.gestures) {
            (0, package_config_1.addPackageToPackageJson)(host, 'hammerjs', HAMMERJS_VERSION);
        }
        const installTaskId = context.addTask(new tasks_1.NodePackageInstallTask());
        context.addTask(new tasks_1.RunSchematicTask('ng-add-setup-project', options), [installTaskId]);
    };
}
exports.default = default_1;
//# sourceMappingURL=index.js.map