import { CdkFooterRow, CdkFooterRowDef, CdkHeaderRow, CdkHeaderRowDef, CdkRow, CdkRowDef, CdkNoDataRow } from '@angular/cdk/table';
import { TemplateRef } from '@angular/core';
import { StyleRenderer } from '@alyle/ui';
import * as i0 from "@angular/core";
/**
 * Header row definition for the ly-table.
 * Captures the header row's template and other header properties such as the columns to display.
 */
export declare class LyHeaderRowDef extends CdkHeaderRowDef {
    static ɵfac: i0.ɵɵFactoryDeclaration<LyHeaderRowDef, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<LyHeaderRowDef, "[lyHeaderRowDef]", never, { "columns": "lyHeaderRowDef"; "sticky": "lyHeaderRowDefSticky"; }, {}, never, never, false>;
}
/**
 * Footer row definition for the ly-table.
 * Captures the footer row's template and other footer properties such as the columns to display.
 */
export declare class LyFooterRowDef extends CdkFooterRowDef {
    static ɵfac: i0.ɵɵFactoryDeclaration<LyFooterRowDef, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<LyFooterRowDef, "[lyFooterRowDef]", never, { "columns": "lyFooterRowDef"; "sticky": "lyFooterRowDefSticky"; }, {}, never, never, false>;
}
/**
 * Data row definition for the ly-table.
 * Captures the data row's template and other properties such as the columns to display and
 * a when predicate that describes when this row should be used.
 */
export declare class LyRowDef<T> extends CdkRowDef<T> {
    static ɵfac: i0.ɵɵFactoryDeclaration<LyRowDef<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<LyRowDef<any>, "[lyRowDef]", never, { "columns": "lyRowDefColumns"; "when": "lyRowDefWhen"; }, {}, never, never, false>;
}
/** Header template container that contains the cell outlet. Adds the right class and role. */
export declare class LyHeaderRow extends CdkHeaderRow {
    readonly sRenderer: StyleRenderer;
    readonly classes: import("@alyle/ui").LyClasses<(theme: import("@alyle/ui").LyStyleUtils & import("@alyle/ui").ThemeConfig & import("./styles").LyTableVariables, ref: import("@alyle/ui").ThemeRef) => {
        $name: string;
        $global: () => (_className: string) => string;
        root: () => (_className: string) => string;
        column: any;
        headerCell: (_className: string) => string;
        footerCell: any;
        cell: any;
        row: any;
        headerRow: (_className: string) => string;
        footerRow: any;
        sticky: (_className: string) => string;
        noDataRow: any;
        fixedLayout: (_className: string) => string;
    }>;
    constructor(sRenderer: StyleRenderer);
    static ɵfac: i0.ɵɵFactoryDeclaration<LyHeaderRow, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<LyHeaderRow, "ly-header-row, tr[ly-header-row]", ["lyHeaderRow"], {}, {}, never, never, false>;
}
/** Footer template container that contains the cell outlet. Adds the right class and role. */
export declare class LyFooterRow extends CdkFooterRow {
    readonly sRenderer: StyleRenderer;
    readonly classes: import("@alyle/ui").LyClasses<(theme: import("@alyle/ui").LyStyleUtils & import("@alyle/ui").ThemeConfig & import("./styles").LyTableVariables, ref: import("@alyle/ui").ThemeRef) => {
        $name: string;
        $global: () => (_className: string) => string;
        root: () => (_className: string) => string;
        column: any;
        headerCell: (_className: string) => string;
        footerCell: any;
        cell: any;
        row: any;
        headerRow: (_className: string) => string;
        footerRow: any;
        sticky: (_className: string) => string;
        noDataRow: any;
        fixedLayout: (_className: string) => string;
    }>;
    constructor(sRenderer: StyleRenderer);
    static ɵfac: i0.ɵɵFactoryDeclaration<LyFooterRow, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<LyFooterRow, "ly-footer-row, tr[ly-footer-row]", ["lyFooterRow"], {}, {}, never, never, false>;
}
/** Data row template container that contains the cell outlet. Adds the right class and role. */
export declare class LyRow extends CdkRow {
    readonly sRenderer: StyleRenderer;
    readonly classes: import("@alyle/ui").LyClasses<(theme: import("@alyle/ui").LyStyleUtils & import("@alyle/ui").ThemeConfig & import("./styles").LyTableVariables, ref: import("@alyle/ui").ThemeRef) => {
        $name: string;
        $global: () => (_className: string) => string;
        root: () => (_className: string) => string;
        column: any;
        headerCell: (_className: string) => string;
        footerCell: any;
        cell: any;
        row: any;
        headerRow: (_className: string) => string;
        footerRow: any;
        sticky: (_className: string) => string;
        noDataRow: any;
        fixedLayout: (_className: string) => string;
    }>;
    constructor(sRenderer: StyleRenderer);
    static ɵfac: i0.ɵɵFactoryDeclaration<LyRow, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<LyRow, "ly-row, tr[ly-row]", ["lyRow"], {}, {}, never, never, false>;
}
/** Row that can be used to display a message when no data is shown in the table. */
export declare class LyNoDataRow extends CdkNoDataRow {
    readonly sRenderer: StyleRenderer;
    readonly classes: import("@alyle/ui").LyClasses<(theme: import("@alyle/ui").LyStyleUtils & import("@alyle/ui").ThemeConfig & import("./styles").LyTableVariables, ref: import("@alyle/ui").ThemeRef) => {
        $name: string;
        $global: () => (_className: string) => string;
        root: () => (_className: string) => string;
        column: any;
        headerCell: (_className: string) => string;
        footerCell: any;
        cell: any;
        row: any;
        headerRow: (_className: string) => string;
        footerRow: any;
        sticky: (_className: string) => string;
        noDataRow: any;
        fixedLayout: (_className: string) => string;
    }>;
    _contentClassName: string;
    constructor(templateRef: TemplateRef<any>, sRenderer: StyleRenderer);
    static ɵfac: i0.ɵɵFactoryDeclaration<LyNoDataRow, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<LyNoDataRow, "ng-template[lyNoDataRow]", never, {}, {}, never, never, false>;
}
