import { LyStyleUtils, Dir, StyleCollection, StyleTemplate } from '@alyle/ui';
import { LyAvatarTheme } from '@alyle/ui/avatar';
import { ExpansionConfig } from '@alyle/ui/expansion';
import { LySnackBarTheme } from '@alyle/ui/snack-bar';
import { LyButtonTheme } from '@alyle/ui/button';
import { LyBadgeTheme } from '@alyle/ui/badge';
import { LyCheckboxTheme } from '@alyle/ui/checkbox';
import { LyFieldTheme } from '@alyle/ui/field';
import { LySliderTheme } from '@alyle/ui/slider';
import { LyToolbarTheme } from '@alyle/ui/toolbar';
import * as i0 from "@angular/core";
export declare class MinimaBase extends LyStyleUtils {
    typography: {
        fontFamily: string;
        htmlFontSize: number;
        fontSize: number;
        gutterTop: number;
        gutterBottom: number;
        lyTyp: {
            [key: string]: StyleCollection<any> | (() => StyleTemplate);
        };
    };
    avatar?: LyAvatarTheme;
    snackBar?: LySnackBarTheme;
    iconButton: {
        size: string;
    };
    icon: {
        fontSize: string;
    };
    breakpoints: {
        XSmall: string;
        Small: string;
        Medium: string;
        Large: string;
        XLarge: string;
        Handset: string;
        Tablet: string;
        Web: string;
        HandsetPortrait: string;
        TabletPortrait: string;
        WebPortrait: string;
        HandsetLandscape: string;
        TabletLandscape: string;
        WebLandscape: string;
    };
    zIndex: {
        toolbar: number;
        drawer: number;
        overlay: number;
    };
    ripple: {
        transition: {
            opacity: string;
            transform: string;
        };
        duration: number;
    };
    animations: {
        curves: {
            standard: string;
            deceleration: string;
            acceleration: string;
            sharp: string;
        };
        durations: {
            complex: number;
            entering: number;
            exiting: number;
        };
    };
    direction: Dir;
    button: LyButtonTheme;
    badge: LyBadgeTheme;
    checkbox: LyCheckboxTheme;
    expansion: ExpansionConfig;
    field: LyFieldTheme;
    toolbar: LyToolbarTheme;
    slider: LySliderTheme;
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<MinimaBase, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<MinimaBase>;
}
