import { ElementRef, Renderer2, OnInit, OnChanges } from '@angular/core';
import { LyTheme2, ThemeVariables, StyleCollection, StyleTemplate, StyleRenderer } from '@alyle/ui';
import * as i0 from "@angular/core";
export interface LyTypographyTheme {
    /** Styles for Typography Component */
    root?: StyleCollection<(() => StyleTemplate)> | (() => StyleTemplate);
    lyTyp?: {
        [name: string]: StyleCollection<(() => StyleTemplate)> | (() => StyleTemplate) | undefined;
    };
}
export interface LyTypographyVariables {
    typography?: LyTypographyTheme;
}
export declare const STYLES: (theme: ThemeVariables & LyTypographyVariables) => {
    $name: string;
    $priority: number;
    root: (_className: string) => string;
    gutterTop: (_className: string) => string;
    gutterBottom: (_className: string) => string;
    gutter: (_className: string) => string;
};
/** @docs-private */
export declare class LyTypographyBase {
    _theme: LyTheme2;
    constructor(_theme: LyTheme2);
}
/** @docs-private */
export declare const LyTypographyMixinBase: import("@alyle/ui/src/common/constructor").Constructor<import("@alyle/ui/src/common/build-common-behaviors").CanStyleUpdater> & import("@alyle/ui/src/common/constructor").Constructor<import("@alyle/ui/src/common/color").CanColor> & typeof LyTypographyBase;
export declare class LyTypography extends LyTypographyMixinBase implements OnInit, OnChanges {
    private _el;
    private renderer;
    readonly sRenderer: StyleRenderer;
    /** @docs-private */
    static readonly и = "LyTypography";
    /** @docs-private */
    readonly classes: import("@alyle/ui").LyClasses<(theme: import("@alyle/ui").LyStyleUtils & import("@alyle/ui").ThemeConfig & LyTypographyVariables) => {
        $name: string;
        $priority: number;
        root: (_className: string) => string;
        gutterTop: (_className: string) => string;
        gutterBottom: (_className: string) => string;
        gutter: (_className: string) => string;
    }>;
    private _lyTyp;
    private _lyTypClass;
    private _gutter;
    private _gutterTop;
    private _gutterBottom;
    private _noWrap;
    private _noWrapClass?;
    set lyTyp(val: string);
    get lyTyp(): string;
    /** The text will truncate with an ellipsis. */
    set noWrap(val: boolean);
    get noWrap(): boolean;
    set gutter(val: boolean);
    get gutter(): boolean;
    set gutterTop(val: boolean);
    get gutterTop(): boolean;
    set gutterBottom(val: boolean);
    get gutterBottom(): boolean;
    constructor(_theme: LyTheme2, _el: ElementRef, renderer: Renderer2, sRenderer: StyleRenderer);
    ngOnInit(): void;
    ngOnChanges(): void;
    private _createTypClass;
    static ɵfac: i0.ɵɵFactoryDeclaration<LyTypography, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<LyTypography, "[lyTyp]", never, { "color": "color"; "lyTyp": "lyTyp"; "noWrap": "noWrap"; "gutter": "gutter"; "gutterTop": "gutterTop"; "gutterBottom": "gutterBottom"; }, {}, never, never, false>;
}
